// PgTweaks.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgTweaks.h"



// CPPgTweaks dialog

IMPLEMENT_DYNAMIC(CPPgTweaks, CPropertyPage)
CPPgTweaks::CPPgTweaks()
	: CPropertyPage(CPPgTweaks::IDD)
{
}

CPPgTweaks::~CPPgTweaks()
{
}

void CPPgTweaks::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CPPgTweaks, CPropertyPage)

	ON_EN_CHANGE(IDC_MAXCON5SEC, OnSettingsChange)
	ON_EN_CHANGE(IDC_MAXSRCEPERFILESOFT, OnEnChangeMaxsourceperfilesoft)
	ON_EN_CHANGE(IDC_MAXSRCEPERFILEUDP, OnEnChangeMaxsourceperfileudp)

END_MESSAGE_MAP()


// CPPgTweaks message handlers


BOOL CPPgTweaks::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CPPgTweaks::LoadSettings(void)
{
	if(m_hWnd)
	{
		CString strBuffer;

		strBuffer.Format("%d", app_prefs->GetMaxConperFive());
		GetDlgItem(IDC_MAXCON5SEC)->SetWindowText(strBuffer);

		if( app_prefs->prefs->maxsourceperfilesoft > app_prefs->prefs->maxsourceperfile * .9)
			app_prefs->prefs->maxsourceperfilesoft = app_prefs->prefs->maxsourceperfile * .9;

		if(app_prefs->prefs->maxsourceperfilesoft == 0xFFFF)
			GetDlgItem(IDC_MAXSRCEPERFILESOFT)->SetWindowText("0"); 
		else
		{
			strBuffer.Format("%d", app_prefs->prefs->maxsourceperfilesoft); 
			GetDlgItem(IDC_MAXSRCEPERFILESOFT)->SetWindowText(strBuffer); 
		}

		if( app_prefs->prefs->maxsourceperfileudp > app_prefs->prefs->maxsourceperfile * .5)
			app_prefs->prefs->maxsourceperfileudp = app_prefs->prefs->maxsourceperfile * .5;

		if(app_prefs->prefs->maxsourceperfileudp == 0xFFFF)
			GetDlgItem(IDC_MAXSRCEPERFILEUDP)->SetWindowText("0"); 
		else
		{
			strBuffer.Format("%d", app_prefs->prefs->maxsourceperfileudp); 
			GetDlgItem(IDC_MAXSRCEPERFILEUDP)->SetWindowText(strBuffer); 
		}
	}
}

BOOL CPPgTweaks::OnApply()
{
	char buffer[510];
	if(GetDlgItem(IDC_MAXCON5SEC)->GetWindowTextLength())
	{
		GetDlgItem(IDC_MAXCON5SEC)->GetWindowText(buffer,20);
		app_prefs->SetMaxDownloadConperFive((atoi(buffer)) ?
			atoi(buffer) : 20);
	}

	if(GetDlgItem(IDC_MAXSRCEPERFILEUDP)->GetWindowTextLength())
	{
		GetDlgItem(IDC_MAXSRCEPERFILEUDP)->GetWindowText(buffer,20);
		app_prefs->prefs->maxsourceperfileudp = (atoi(buffer)) ? atoi(buffer) : 1;
	}

	if( app_prefs->prefs->maxsourceperfileudp > app_prefs->prefs->maxsourceperfile * .5)
		app_prefs->prefs->maxsourceperfileudp = app_prefs->prefs->maxsourceperfile * .5;

	if(GetDlgItem(IDC_MAXSRCEPERFILESOFT)->GetWindowTextLength())
	{ 
		GetDlgItem(IDC_MAXSRCEPERFILESOFT)->GetWindowText(buffer,20);
		app_prefs->prefs->maxsourceperfilesoft = (atoi(buffer)) ? atoi(buffer) : 0xFFFF; 
	} 

	if( app_prefs->prefs->maxsourceperfilesoft > app_prefs->prefs->maxsourceperfile * .9)
		app_prefs->prefs->maxsourceperfilesoft = app_prefs->prefs->maxsourceperfile * .9;

//	app_prefs->Save();
	LoadSettings();
	SetModified(FALSE);
	return CPropertyPage::OnApply();
}

void CPPgTweaks::Localize(void)
{	
	if(m_hWnd)
	{
		SetWindowText(GetResString(IDS_PW_TWEAK));
		GetDlgItem(IDC_MAXCON5SECLABEL )->SetWindowText(GetResString(IDS_MAXCON5SECLABEL));
		GetDlgItem(IDC_WARNING)->SetWindowText(GetResString(IDS_WARNING));
		GetDlgItem(IDC_MAXSRCUDP_LBL)->SetWindowText(GetResString(IDS_MAXSRCUDP_LBL));
		GetDlgItem(IDC_MAXSRCSOFT_LBL)->SetWindowText(GetResString(IDS_SOFTLIMIT));
	}
}

